config/routes.rb
Rails.application.routes.draw do
  root "authorities#index"
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    passwords: 'users/passwords'
  }
  
  resources :authorities
  resources :basic_informations
  resources :infrastructures
  resources :events
  resources :departments do
    collection do
      get :get_subjects
    end
  end
end

app/models/affiliated_college.rb
class AffiliatedCollege < ApplicationRecord
	belongs_to :basic_information
	belongs_to :infrastructure
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/authority.rb
class Authority < ApplicationRecord
	belongs_to :designation
	validates :name, :designation_id, presence: true
	mount_uploader :upload_list, FileUploader
end

app/models/basic_information.rb
class BasicInformation < ApplicationRecord
	include PgSearch::Model
 	pg_search_scope :search_by_name, against: :university_name

	validates :university_name, presence: true
	has_one :naac_status
	has_many :affiliated_colleges
	has_many :programmes_offereds
	accepts_nested_attributes_for :naac_status, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :affiliated_colleges, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :programmes_offereds, reject_if: :all_blank, allow_destroy: true

end

app/models/department.rb
class Department < ApplicationRecord
	validates :department_list_id, :program_id, presence: true
	belongs_to :program
	belongs_to :subject, optional: true
	belongs_to :department_list
	has_many :faculties
	has_one :student
	has_one :fee_structure
	accepts_nested_attributes_for :faculties, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :student, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :fee_structure, reject_if: :all_blank, allow_destroy: true

	def fetch_faculties
		if self.faculties.present?
			self.faculties.includes(:faculty_designation).order("faculty_designations.position ASC")
		else
			[]
		end
	end
end

app/models/department_list.rb
class DepartmentList < ApplicationRecord
	has_many :departments
	has_many :faculties, through: :departments
	has_many :students, through: :departments
end

app/models/designation.rb
class Designation < ApplicationRecord
	validates :name, presence: true
	has_many :authorities
end

app/models/event.rb
class Event < ApplicationRecord
	validates :event_file, :department_list_id, presence: true
	belongs_to :department_list
	mount_uploader :event_file, FileUploader
	enum semester: { even: 'even', odd: 'odd' }

end

app/models/faculty.rb
class Faculty < ApplicationRecord
	belongs_to :faculty_designation
	belongs_to :department, optional: true
	mount_uploader :resume, FileUploader
end

app/models/fee_structure.rb
class FeeStructure < ApplicationRecord
	belongs_to :department
end

app/models/hostel.rb
class Hostel < ApplicationRecord
	# validates :hostel_type, presence: true
	enum hostel_type: {"boy's hostel": 0, "girl's hostel": 1}
	belongs_to :infrastructure
end

app/models/infrastructure.rb
class Infrastructure < ApplicationRecord
	require 'csv'
	validates :campus, presence: true
	has_many :hostels, dependent: :destroy
	has_many :libraries, dependent: :destroy
	has_many :ict_infrastructures, dependent: :destroy

	enum campus: {"main campus": 0, "constituent college": 1, "off campus": 2, "out reach": 3}
	
	accepts_nested_attributes_for :hostels, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :libraries, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :ict_infrastructures, reject_if: :all_blank, allow_destroy: true

	def self.to_csv(infrastructures)
    #headers = ["Name", "Campus", "Land Availability (in acres)", "No of Classes", "No of Labs", "Hostel Name", "Hostel Type", "Total Boys", "Total Girls", "Library Name", "Total Books", "Total E-books", "Total Journals", "Total E-journals", "ICT Type", "Availability", "No of ICT Enabled Classes", "Speed", "Service Provide", "Bandwidth"]
     headers = ["Name", "Campus", "Land Availability (in acres)", "No of Classes", "No of Labs"]
    CSV.generate(headers: true) do |csv|
      csv << headers
      if infrastructures.present?
        infrastructures.each do |infra|
        	# hostels_attributes = []
   				# if infra.hostels.present?
   				# 	infra.hostels.each do |h|
   				# 		hostels_attributes << [
   				# 			h.name,
   				# 			h.hostel_type,
   				# 			h.total_boys,
   				# 			h.total_girls
   				# 		].flatten
   				# 	end
   				# end

   				# libraries_attributes = []
   				# if infra.libraries.present?
   				# 	infra.libraries.each do |l|
   				# 		hostels_attributes << [
   				# 			l.name,
   				# 			l.total_books,
   				# 			l.total_ebooks,
   				# 			l.total_journals,
   				# 			l.total_ejournals,
   				# 		].flatten
   				# 	end
   				# end

   				# ict_attributes = []
   				# if infra.ict_infrastructures.present?
   				# 	infra.ict_infrastructures.each do |i|
   				# 		hostels_attributes << [
   				# 			i.ict_type,
   				# 			i.availability,
   				# 			i.no_of_ict_enabled_classes,
   				# 			i.speed,
   				# 			i.service_provider,
   				# 			i.bandwidth
   				# 		].flatten
   				# 	end
   				# end

          csv << [
            infra.name,
            infra.campus,
            infra.land_availability,
            infra.no_of_classes,
            infra.no_of_labs
          ].flatten
        end

      end
    end
  end 

end

app/models/library.rb
class Library < ApplicationRecord
	belongs_to :infrastructure
end

app/models/naac_status.rb
class NaacStatus < ApplicationRecord
	validates :grade, presence: true
	belongs_to :basic_information
end

app/models/program.rb
class Program < ApplicationRecord
	validates :name, presence: true
	has_many :subjects
end

app/models/sanctioned_intake.rb
class SanctionedIntake < ApplicationRecord
	belongs_to :student
	enum intake_type: {"government": 0, "management": 1}
end

app/models/student.rb
class Student < ApplicationRecord
	belongs_to :department
end

app/models/subject.rb
class Subject < ApplicationRecord
	validates :name, presence: true
	belongs_to :program
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/helpers/events_helper.rb
module EventsHelper

	def semester_collection
		[
			["Even", "even"],
			["Odd", "odd"]
		]
	end
end

app/views/layouts/_flash_messages.html.erb
<div class="container-fluid">
  <div class="row">
    <% if flash[:notice] %>
      <div class="alert alert-info">
        <%= simple_format(flash[:notice]) %>
      </div>
    <% end %>
    <% if flash[:error] %>
      <div class="alert alert-danger">
        <%= simple_format(flash[:error]) %>
      </div>
    <% end %>
    <% if flash[:alert] %>
      <div class="alert alert-danger">
        <%= simple_format(flash[:alert]) %>
      </div>
    <% end %>
    <% if flash[:warning] %>
      <div class="alert alert-warning">
        <%= simple_format(flash[:warning]) %>
      </div>
    <% end %>
  </div>
</div>

app/views/layouts/_navbar.html.erb
<nav class="navbar navbar-expand-lg bg-nav">
  <div class="container-fluid">
    <%= link_to image_tag("logo.svg", class: "logo-img img-fluid"), root_path, class: "navbar-brand logo" %>
    <button class="navbar-toggler navbar-toggler_sm" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
    </button>
    <% if user_signed_in? %>
      <div class="collapse navbar-collapse navbar_toogle d-flex justify-content-between" id="navbarSupportedContent">
        <ul class="navbar-nav me-auto mb-2 mb-lg-0">
          <li class="nav-item">
            <%= link_to 'Leadership', authorities_path, class: is_same_route?(authorities_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Basic Informations', basic_informations_path, class: is_same_route?(basic_informations_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Infrastructures', infrastructures_path, class: is_same_route?(infrastructures_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Departments', departments_path, class: is_same_route?(departments_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Events', events_path , class: is_same_route?(events_path) %>
          </li>
          <li class="nav-item">
            <%= link_to "Sign Out", destroy_user_session_path, method: :delete, class: is_same_route?(destroy_user_session_path) %>
          </li>
        </ul>
        <div class=" d-flex justify-content-between">
          <%= simple_form_for :search, as: :search, url: basic_informations_path, method: :get, html: { class: "d-flex position-relative", role: "search"} do |f| %>
            <%= text_field_tag :name, params[:name], class: 'form-control me-2 search-bar-input', placeholder: "Search" %>
            <%= image_submit_tag("search.svg", class: 'btn search-bar mb-1 me-2') %>
          <% end %>
          <div class="nav-right">
            <div class="dropdown show">
              <a class="btn nav-link admin-btn" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><%= current_user.try(:name) %><%= image_tag("down.svg", class: "pl-2") %>
              </a>
              <div class="dropdown-menu dropdown-items" aria-labelledby="dropdownMenuLink">
                <div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    <% end %>
  </div>
</nav>

app/views/layouts/_sidebar.html.erb
<div class="fixed-sidebar">
  <aside class="app-sidebar">
    <div class="container-fluid">
      <ul class="nav flex-column">
        <% if user_signed_in? %>
          <li class="nav-item">
            <%= link_to 'Leadership', authorities_path, class: is_same_route?(authorities_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Basic Informations', basic_informations_path, class: is_same_route?(basic_informations_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Infrastructures', infrastructures_path, class: is_same_route?(infrastructures_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Departments', departments_path, class: is_same_route?(departments_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Calendar of Events', events_path , class: is_same_route?(events_path) %>
          </li>
        <% end %>
      </ul>
    </div>
  </aside>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Kshec Dashboard</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_include_tag "jquery" %>
    <%= javascript_importmap_tags %>

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/css/bootstrap-datepicker.min.css" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/js/bootstrap-datepicker.min.js"></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.min.js"
      integrity="sha512-2ImtlRlf2VVmiGZsjm9bEyhjGW4dU7B6TNwh/hx/iSByxNENtj3WVE6o/9Lj4TJeVXPi4bnOIMXFIJJAeufa0A=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    ></script>
  </head>

  <body>
    <%= render 'layouts/navbar' %>
    <%#= render 'layouts/sidebar' %>
    <section>
      <div class="container-fluid">
        <%= render 'layouts/flash_messages' %>
        <%= yield %>
      </div>
    </section>
  </body>
</html>